window.Gleam.initSearch([{"doc":"scrapbook","title":"scrapbook","content":"# scrapbook\n\nGleam package for both targets that can scrape parts of Facebook.\n\n**Currently, this package only supports scraping single events and events from a page (list of events or all event details).**\n\n[![Package Version](https://img.shields.io/hexpm/v/scrapbook)](https://hex.pm/packages/scrapbook)\n[![Package License](https://img.shields.io/hexpm/l/scrapbook)](https://hex.pm/packages/scrapbook)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/scrapbook/)\n![Target: Erlang](https://img.shields.io/badge/target-erlang-a90432)\n![Target: JavaScript](https://img.shields.io/badge/target-javascript-f7e018)\n\n```sh\ngleam add scrapbook\n```\n\nPlease refer to the documentation for code examples. It can be found at &lt;https://hexdocs.pm/scrapbook&gt;.\n\nAll contributions are welcome. If you have any questions, please create an issue in the repository.\n\n## Other information\n\nFacebook&#39;s terms of service prohibit automated scraping of their site. Use this package at your own risk.\n\nRead more: [Automated Data Collection Terms](https://www.facebook.com/legal/automated_data_collection_terms)\n\n## Acknowledgements\n\n- [@francescov1](https://github.com/francescov1) for the [facebook-event-scraper](https://github.com/francescov1/facebook-event-scraper) (MIT) TypeScript library, which was an inspiration and the basis for the event scraping logic.\n","url":"index.html"},{"doc":"scrapbook/error","title":"FindKeyValueError","content":"pub type FindKeyValueError {\n  NoPrefix(key: String)\n  FindValueError(FindValueError)\n}\n This type represents the reasons why a key or its value could not be found.\nNoPrefix(key: String)\n No prefix with the specified key was found. This may mean that the prefix\n exists in JSON, but its value does not match the required structure and an\n attempt to find another occurrence of the key failed.\n\nFindValueError(FindValueError)\n Error finding a value.\n\nSynonyms:\nscrapbook/error.FindKeyValueError\nscrapbook/error FindKeyValueError","url":"scrapbook/error.html#FindKeyValueError"},{"doc":"scrapbook/error","title":"FindValueError","content":"pub type FindValueError {\n  NoValue\n  NoGraphemes\n  InvalidStartCharacter\n  NoValueEndFound(IndexSearchError)\n}\n This type represents the reasons why a value could not be found.\nNoValue\n The key had no assigned value - the value was null.\n\nNoGraphemes\n There were no graphemes in a list after converting from string.\n\nInvalidStartCharacter\n Invalid start character of a value - value of the key is not an object or\n an array.\n\nNoValueEndFound(IndexSearchError)\n Error in finding an index that indicates the end character of a value.\n\nSynonyms:\nscrapbook/error.FindValueError\nscrapbook/error FindValueError","url":"scrapbook/error.html#FindValueError"},{"doc":"scrapbook/error","title":"IndexSearchError","content":"pub type IndexSearchError {\n  NoIndexFound(last_index: Int)\n}\n This type represents the reasons why the search for the character index in\n string may fail.\nNoIndexFound(last_index: Int)\n Error finding an index with an index of a last analyzed character.\n\nSynonyms:\nscrapbook/error.IndexSearchError\nscrapbook/error IndexSearchError","url":"scrapbook/error.html#IndexSearchError"},{"doc":"scrapbook/error","title":"PropertyError","content":"pub type PropertyError {\n  FindKeyValueError(FindKeyValueError)\n  DecodeError(json.DecodeError)\n  ValidateError\n}\n This type represents the reasons why decoding of the JSON failed.\nFindKeyValueError(FindKeyValueError)\n Error in finding the desired key or its value.\n\nDecodeError(json.DecodeError)\n Error decoding JSON structure.\n\nValidateError\n Error validating decoded data with the passed validator.\n\nSynonyms:\nscrapbook/error.PropertyError\nscrapbook/error PropertyError","url":"scrapbook/error.html#PropertyError"},{"doc":"scrapbook/error","title":"RequestError","content":"pub type RequestError {\n  ConstructionError(url: String)\n}\n This type represents the reasons why constructing the HTTP request might fail.\nConstructionError(url: String)\n Error constructing request from URL.\n\nSynonyms:\nscrapbook/error.RequestError\nscrapbook/error RequestError","url":"scrapbook/error.html#RequestError"},{"doc":"scrapbook/error","title":"ScrapeError","content":"pub type ScrapeError {\n  UrlError\n  PropertyError(List(PropertyError))\n  RequestError(RequestError)\n}\n This type represents the reasons why scraping the event might fail.\nUrlError\n Error creating the target URL from the input.\n\nPropertyError(List(PropertyError))\n Error parsing a JSON property from received HTML.\n\nRequestError(RequestError)\n Error constructing the HTTP request.\n\nSynonyms:\nscrapbook/error.ScrapeError\nscrapbook/error ScrapeError","url":"scrapbook/error.html#ScrapeError"},{"doc":"scrapbook/error","title":"scrapbook/error","content":"","url":"scrapbook/error.html"},{"doc":"scrapbook/event","title":"EventBasicData","content":"pub type EventBasicData {\n  EventBasicData(\n    id: String,\n    name: String,\n    start_timestamp: Int,\n    formatted_date: String,\n    photo: Option(EventPhoto),\n    video: Option(EventVideo),\n    url: String,\n    is_online: Bool,\n    parent: Option(EventParent),\n    siblings: List(EventSibling),\n  )\n}\n\nEventBasicData(\n  id: String,\n  name: String,\n  start_timestamp: Int,\n  formatted_date: String,\n  photo: Option(EventPhoto),\n  video: Option(EventVideo),\n  url: String,\n  is_online: Bool,\n  parent: Option(EventParent),\n  siblings: List(EventSibling),\n)\n\n\nSynonyms:\nscrapbook/event.EventBasicData\nscrapbook/event EventBasicData","url":"scrapbook/event.html#EventBasicData"},{"doc":"scrapbook/event","title":"EventData","content":"pub type EventData {\n  EventData(\n    basic_data: EventBasicData,\n    description: String,\n    place: Option(EventPlace),\n    hosts: List(EventHost),\n    time_details: EventTimeDetails,\n    ticket_url: Option(String),\n    users_responded: Option(Int),\n  )\n}\n\nEventData(\n  basic_data: EventBasicData,\n  description: String,\n  place: Option(EventPlace),\n  hosts: List(EventHost),\n  time_details: EventTimeDetails,\n  ticket_url: Option(String),\n  users_responded: Option(Int),\n)\n\n\nSynonyms:\nscrapbook/event.EventData\nscrapbook/event EventData","url":"scrapbook/event.html#EventData"},{"doc":"scrapbook/event","title":"EventHost","content":"pub type EventHost {\n  EventHost(\n    id: String,\n    name: String,\n    url: String,\n    type_: HostType,\n    image_uri: String,\n  )\n}\n\nEventHost(\n  id: String,\n  name: String,\n  url: String,\n  type_: HostType,\n  image_uri: String,\n)\n\n\nSynonyms:\nscrapbook/event.EventHost\nscrapbook/event EventHost","url":"scrapbook/event.html#EventHost"},{"doc":"scrapbook/event","title":"EventParent","content":"pub type EventParent {\n  EventParent(id: String)\n}\n\nEventParent(id: String)\n\n\nSynonyms:\nscrapbook/event.EventParent\nscrapbook/event EventParent","url":"scrapbook/event.html#EventParent"},{"doc":"scrapbook/event","title":"EventPhoto","content":"pub type EventPhoto {\n  EventPhoto(url: String, id: String, image_uri: Option(String))\n}\n\nEventPhoto(url: String, id: String, image_uri: Option(String))\n\n\nSynonyms:\nscrapbook/event.EventPhoto\nscrapbook/event EventPhoto","url":"scrapbook/event.html#EventPhoto"},{"doc":"scrapbook/event","title":"EventPlace","content":"pub type EventPlace {\n  Online(url: Option(String), type_: OnlineType)\n  Offline(\n    id: String,\n    name: String,\n    description: Option(String),\n    url: Option(String),\n    location: Option(OfflineLocation),\n    type_: OfflineType,\n    address: Option(String),\n    city: Option(OfflineCity),\n  )\n}\n\nOnline(url: Option(String), type_: OnlineType)\n\n\nOffline(\n  id: String,\n  name: String,\n  description: Option(String),\n  url: Option(String),\n  location: Option(OfflineLocation),\n  type_: OfflineType,\n  address: Option(String),\n  city: Option(OfflineCity),\n)\n\n\nSynonyms:\nscrapbook/event.EventPlace\nscrapbook/event EventPlace","url":"scrapbook/event.html#EventPlace"},{"doc":"scrapbook/event","title":"EventSibling","content":"pub type EventSibling {\n  EventSibling(\n    id: String,\n    start_timestamp: Int,\n    end_timestamp: Option(Int),\n    parent: EventParent,\n  )\n}\n\nEventSibling(\n  id: String,\n  start_timestamp: Int,\n  end_timestamp: Option(Int),\n  parent: EventParent,\n)\n\n\nSynonyms:\nscrapbook/event.EventSibling\nscrapbook/event EventSibling","url":"scrapbook/event.html#EventSibling"},{"doc":"scrapbook/event","title":"EventTimeDetails","content":"pub type EventTimeDetails {\n  EventTimeDetails(\n    start_timestamp: Int,\n    end_timestamp: Int,\n    timezone: String,\n  )\n}\n\nEventTimeDetails(\n  start_timestamp: Int,\n  end_timestamp: Int,\n  timezone: String,\n)\n\n\nSynonyms:\nscrapbook/event.EventTimeDetails\nscrapbook/event EventTimeDetails","url":"scrapbook/event.html#EventTimeDetails"},{"doc":"scrapbook/event","title":"EventVideo","content":"pub type EventVideo {\n  EventVideo(url: String, id: String, image_uri: Option(String))\n}\n\nEventVideo(url: String, id: String, image_uri: Option(String))\n\n\nSynonyms:\nscrapbook/event.EventVideo\nscrapbook/event EventVideo","url":"scrapbook/event.html#EventVideo"},{"doc":"scrapbook/event","title":"HostType","content":"pub type HostType {\n  User\n  Page\n}\n\nUser\n\n\nPage\n\n\nSynonyms:\nscrapbook/event.HostType\nscrapbook/event HostType","url":"scrapbook/event.html#HostType"},{"doc":"scrapbook/event","title":"OfflineCity","content":"pub type OfflineCity {\n  OfflineCity(name: String, id: String)\n}\n\nOfflineCity(name: String, id: String)\n\n\nSynonyms:\nscrapbook/event.OfflineCity\nscrapbook/event OfflineCity","url":"scrapbook/event.html#OfflineCity"},{"doc":"scrapbook/event","title":"OfflineLocation","content":"pub type OfflineLocation {\n  OfflineLocation(\n    latitude: Float,\n    longitude: Float,\n    country_code: Option(String),\n  )\n}\n\nOfflineLocation(\n  latitude: Float,\n  longitude: Float,\n  country_code: Option(String),\n)\n\n\nSynonyms:\nscrapbook/event.OfflineLocation\nscrapbook/event OfflineLocation","url":"scrapbook/event.html#OfflineLocation"},{"doc":"scrapbook/event","title":"OfflineType","content":"pub type OfflineType {\n  Text\n  Place\n  City\n}\n\nText\n\n\nPlace\n\n\nCity\n\n\nSynonyms:\nscrapbook/event.OfflineType\nscrapbook/event OfflineType","url":"scrapbook/event.html#OfflineType"},{"doc":"scrapbook/event","title":"OnlineType","content":"pub type OnlineType {\n  MessengerRoom\n  ThirdParty\n  FacebookLive\n  Other\n}\n\nMessengerRoom\n\n\nThirdParty\n\n\nFacebookLive\n\n\nOther\n\n\nSynonyms:\nscrapbook/event.OnlineType\nscrapbook/event OnlineType","url":"scrapbook/event.html#OnlineType"},{"doc":"scrapbook/event","title":"construct_event_request_from_id","content":"pub fn construct_event_request_from_id(\n  id: String,\n  user_agent: String,\n) -&gt; Result(Request(String), ScrapeError)\n Construct the request for the event with a given ID.\nSynonyms:\nscrapbook/event.construct_event_request_from_id\nscrapbook/event construct_event_request_from_id","url":"scrapbook/event.html#construct_event_request_from_id"},{"doc":"scrapbook/event","title":"construct_event_request_from_url","content":"pub fn construct_event_request_from_url(\n  url: String,\n  user_agent: String,\n) -&gt; Result(Request(String), ScrapeError)\n Construct the request for the event with a given URL.\nSynonyms:\nscrapbook/event.construct_event_request_from_url\nscrapbook/event construct_event_request_from_url","url":"scrapbook/event.html#construct_event_request_from_url"},{"doc":"scrapbook/event","title":"get_event","content":"pub fn get_event(\n  html: String,\n) -&gt; Result(EventData, List(PropertyError))\n Get all possible event data from the given HTML string.\nSynonyms:\nscrapbook/event.get_event\nscrapbook/event get_event","url":"scrapbook/event.html#get_event"},{"doc":"scrapbook/event","title":"scrape_event_response","content":"pub fn scrape_event_response(\n  resp: Response(String),\n) -&gt; Result(EventData, ScrapeError)\n Scrape the event from the response received for a previously generated event\n request.\nSynonyms:\nscrapbook/event.scrape_event_response\nscrapbook/event scrape_event_response","url":"scrapbook/event.html#scrape_event_response"},{"doc":"scrapbook/event","title":"scrapbook/event","content":" # Examples\n\n You can use this module to create HTTP requests and parse HTTP responses,\n which allows you to use this module in all targets.\n\n ## Single event\n\n ```gleam\n import gleam/httpc\n import gleam/io\n import gleam/result\n import scrapbook/event\n\n fn single_event() -&gt; Result(event.EventData, Nil) {\n   use req &lt;- result.try(result.replace_error(\n     event.construct_event_request_from_url(\n       &quot;https://www.facebook.com/events/2221600491537520&quot;,\n       user_agent,\n     ),\n     Nil,\n   ))\n   use resp &lt;- result.try(result.replace_error(httpc.send(req), Nil))\n   result.replace_error(event.scrape_event_response(resp), Nil)\n }\n\n pub fn main() {\n   let assert Ok(single_event) = single_event()\n   io.debug(single_event)\n }\n ```\n\n ### JavaScript target\n\n ```gleam\n import gleam/fetch\n import gleam/io\n import gleam/javascript/promise\n import gleam/result\n import scrapbook/event\n\n fn single_event() -&gt; promise.Promise(Result(event.EventData, Nil)) {\n   use req &lt;- promise.try_await(\n     promise.resolve(result.replace_error(\n       event.construct_event_request_from_url(\n         &quot;https://www.facebook.com/events/2221600491537520&quot;,\n         user_agent,\n       ),\n       Nil,\n     )),\n   )\n   use resp &lt;- promise.try_await(\n     promise.map(fetch.send(req), result.replace_error(_, Nil)),\n   )\n   use resp &lt;- promise.try_await(\n     promise.map(fetch.read_text_body(resp), result.replace_error(_, Nil)),\n   )\n   promise.resolve(result.replace_error(event.scrape_event_response(resp), Nil))\n }\n\n pub fn main() {\n   use single_event &lt;- promise.try_await(single_event())\n   io.debug(single_event)\n   promise.resolve(Ok(Nil))\n }\n ```\n\n ## Single event with redirects\n\n ```gleam\n import gleam/dict\n import gleam/http/request.{type Request}\n import gleam/http/response.{type Response}\n import gleam/httpc\n import gleam/io\n import gleam/result\n import gleam/uri\n import scrapbook/event\n\n fn send_redir(req: Request(String)) -&gt; Result(Response(String), Nil) {\n   case req |&gt; httpc.send {\n     Ok(resp) -&gt; {\n       case resp.status &gt;= 300 &amp;&amp; resp.status &lt; 400 {\n         True -&gt; {\n           let headers = dict.from_list(resp.headers)\n           use location &lt;- result.try(result.replace_error(\n             headers |&gt; dict.get(&quot;location&quot;),\n             Nil,\n           ))\n           use uri &lt;- result.try(uri.parse(location))\n           send_redir(req |&gt; request.set_path(uri.path))\n         }\n         False -&gt; Ok(resp)\n       }\n     }\n     Error(_) -&gt; Error(Nil)\n   }\n }\n\n fn single_event_redir() -&gt; Result(event.EventData, Nil) {\n   use req &lt;- result.try(result.replace_error(\n     event.construct_event_request_from_url(\n       &quot;https://www.facebook.com/events/1137956700212933/1137956706879599/&quot;,\n       user_agent,\n     ),\n     Nil,\n   ))\n   use resp &lt;- result.try(send_redir(req))\n   result.replace_error(event.scrape_event_response(resp), Nil)\n }\n\n pub fn main() {\n   let assert Ok(single_event_redir) = single_event_redir()\n   io.debug(single_event_redir)\n }\n ```","url":"scrapbook/event.html"},{"doc":"scrapbook/page","title":"PageEventCollection","content":"pub type PageEventCollection {\n  PageEventCollection(\n    name: String,\n    count: Int,\n    items: List(PageEventItem),\n  )\n}\n\nPageEventCollection(\n  name: String,\n  count: Int,\n  items: List(PageEventItem),\n)\n\n\nSynonyms:\nscrapbook/page.PageEventCollection\nscrapbook/page PageEventCollection","url":"scrapbook/page.html#PageEventCollection"},{"doc":"scrapbook/page","title":"PageEventItem","content":"pub type PageEventItem {\n  PageEventItem(id: String, name: String, canceled: Bool)\n}\n\nPageEventItem(id: String, name: String, canceled: Bool)\n\n\nSynonyms:\nscrapbook/page.PageEventItem\nscrapbook/page PageEventItem","url":"scrapbook/page.html#PageEventItem"},{"doc":"scrapbook/page","title":"construct_event_collection_request_from_url","content":"pub fn construct_event_collection_request_from_url(\n  url: String,\n  user_agent: String,\n) -&gt; Result(Request(String), ScrapeError)\n Construct the request for the page&#39;s event collection with a given URL.\nSynonyms:\nscrapbook/page.construct_event_collection_request_from_url\nscrapbook/page construct_event_collection_request_from_url","url":"scrapbook/page.html#construct_event_collection_request_from_url"},{"doc":"scrapbook/page","title":"construct_event_items_requests","content":"pub fn construct_event_items_requests(\n  items: List(PageEventItem),\n  user_agent: String,\n) -&gt; Result(List(Request(String)), ScrapeError)\n Construct the list of requests for the page&#39;s event items.\nSynonyms:\nscrapbook/page.construct_event_items_requests\nscrapbook/page construct_event_items_requests","url":"scrapbook/page.html#construct_event_items_requests"},{"doc":"scrapbook/page","title":"construct_past_event_collection_request_from_name","content":"pub fn construct_past_event_collection_request_from_name(\n  name: String,\n  user_agent: String,\n) -&gt; Result(Request(String), ScrapeError)\n Construct the request for the page&#39;s past events collection with a given\n name.\nSynonyms:\nscrapbook/page.construct_past_event_collection_request_from_name\nscrapbook/page construct_past_event_collection_request_from_name","url":"scrapbook/page.html#construct_past_event_collection_request_from_name"},{"doc":"scrapbook/page","title":"construct_upcoming_event_collection_request_from_name","content":"pub fn construct_upcoming_event_collection_request_from_name(\n  name: String,\n  user_agent: String,\n) -&gt; Result(Request(String), ScrapeError)\n Construct the request for the page&#39;s upcoming events collection with a given\n name.\nSynonyms:\nscrapbook/page.construct_upcoming_event_collection_request_from_name\nscrapbook/page construct_upcoming_event_collection_request_from_name","url":"scrapbook/page.html#construct_upcoming_event_collection_request_from_name"},{"doc":"scrapbook/page","title":"get_event_collection","content":"pub fn get_event_collection(\n  html: String,\n) -&gt; Result(PageEventCollection, List(PropertyError))\n Get a collection of page event items from the given HTML string.\nSynonyms:\nscrapbook/page.get_event_collection\nscrapbook/page get_event_collection","url":"scrapbook/page.html#get_event_collection"},{"doc":"scrapbook/page","title":"scrape_event_collection_response","content":"pub fn scrape_event_collection_response(\n  resp: Response(String),\n) -&gt; Result(PageEventCollection, ScrapeError)\n Scrape the page event collection from the response received for a previously\n generated page event collection request.\nSynonyms:\nscrapbook/page.scrape_event_collection_response\nscrapbook/page scrape_event_collection_response","url":"scrapbook/page.html#scrape_event_collection_response"},{"doc":"scrapbook/page","title":"scrape_event_items_responses","content":"pub fn scrape_event_items_responses(\n  resps: List(Response(String)),\n) -&gt; Result(List(EventData), ScrapeError)\n Scrape the list of events from the responses received for previously\n generated page event item requests.\nSynonyms:\nscrapbook/page.scrape_event_items_responses\nscrapbook/page scrape_event_items_responses","url":"scrapbook/page.html#scrape_event_items_responses"},{"doc":"scrapbook/page","title":"scrapbook/page","content":" # Examples\n\n You can use this module to create HTTP requests and parse HTTP responses,\n which allows you to use this module in all targets.\n\n ## Event collection\n\n ```gleam\n import gleam/httpc\n import gleam/io\n import gleam/result\n import scrapbook/page\n\n fn event_collection() -&gt; Result(page.PageEventCollection, Nil) {\n   use req &lt;- result.try(result.replace_error(\n     page.construct_upcoming_event_collection_request_from_name(\n       &quot;CodeSyncGlobal&quot;,\n       user_agent,\n     ),\n     Nil,\n   ))\n   use resp &lt;- result.try(result.replace_error(httpc.send(req), Nil))\n   result.replace_error(page.scrape_event_collection_response(resp), Nil)\n }\n\n pub fn main() {\n   let assert Ok(event_collection) = event_collection()\n   io.debug(event_collection)\n }\n ```\n\n ## Event collection items (events)\n\n ```gleam\n import gleam/http/request.{type Request}\n import gleam/http/response.{type Response}\n import gleam/httpc\n import gleam/io\n import gleam/result\n import scrapbook/event\n import scrapbook/page\n\n fn do_send_many(\n   reqs: List(Request(String)),\n   resps: List(Response(String)),\n ) -&gt; Result(List(Response(String)), Nil) {\n   case reqs {\n     [] -&gt; Ok(resps)\n     [first, ..rest] -&gt; {\n       use resp &lt;- result.try(result.replace_error(httpc.send(first), Nil))\n       do_send_many(rest, [resp, ..resps])\n     }\n   }\n }\n\n fn send_many(reqs: List(Request(String))) -&gt; Result(List(Response(String)), Nil) {\n   do_send_many(reqs, [])\n }\n\n fn event_items(\n   event_collection: page.PageEventCollection,\n ) -&gt; Result(List(event.EventData), Nil) {\n   use reqs &lt;- result.try(result.replace_error(\n     page.construct_event_items_requests(event_collection.items, user_agent),\n     Nil,\n   ))\n   use resps &lt;- result.try(send_many(reqs))\n   result.replace_error(page.scrape_event_items_responses(resps), Nil)\n }\n\n pub fn main() {\n   // First, get the page&#39;s event collection...\n\n   let assert Ok(event_items) = event_items(event_collection)\n   io.debug(event_items)\n }\n ```","url":"scrapbook/page.html"}]);